/************************************************************************************/
/*  Program name CAPFNDIMP_ORG_UNITS_PARENT.sql                                            */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

--ALTER TRIGGER HR_ALL_ORGANIZATION_UNITS_OVN DISABLE;
--ALTER TRIGGER HR_ALL_ORGANIZATION_UNITS_WHO DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDIMP_ORG_UNITS_PARENT';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_ORG_UNITS_PARENT;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	--  RENAME
	UPDATE
		HR_ALL_ORGANIZATION_UNITS
	SET
		NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(NAME,1,4),NAME)
	WHERE	ORGANIZATION_ID	IN	(
								SELECT
									ORGANIZATION_ID
								FROM
									CRST_FND_ORG_UNITS_PARENT
								);

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	HR_ORGANIZATION_UNITS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_ORG_UNITS_MAP VALUES
			(
			C1.ORGANIZATION_ID,
			C1.BUSINESS_GROUP_ID,
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.NAME,1,4),C1.NAME),
			lv_Next_Seq_ID,
			CAPBRIMP_MAPPING.GetBGMapping(C1.BUSINESS_GROUP_ID),
			C1.NAME
			);

			INSERT INTO HR_ALL_ORGANIZATION_UNITS
			VALUES
			(
			lv_Next_Seq_ID,											--ORGANIZATION_ID,
			CAPBRIMP_MAPPING.GetBGMapping(C1.BUSINESS_GROUP_ID),		--BUSINESS_GROUP_ID,
			C1.COST_ALLOCATION_KEYFLEX_ID,
			CAPBRIMP_COMMON.GetLocation(C1.LOCATION_CODE),			--LOCATION_ID,
			C1.SOFT_CODING_KEYFLEX_ID,
			C1.DATE_FROM,
			C1.NAME,
			C1.COMMENTS,
			C1.DATE_TO,
			C1.INTERNAL_EXTERNAL_FLAG,
			C1.INTERNAL_ADDRESS_LINE,
			C1.TYPE,
			C1.REQUEST_ID,
			C1.PROGRAM_APPLICATION_ID,
			C1.PROGRAM_ID,
			C1.PROGRAM_UPDATE_DATE,
			C1.ATTRIBUTE_CATEGORY,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.ATTRIBUTE9,
			C1.ATTRIBUTE10,
			C1.ATTRIBUTE11,
			C1.ATTRIBUTE12,
			C1.ATTRIBUTE13,
			C1.ATTRIBUTE14,
			C1.ATTRIBUTE15,
			C1.ATTRIBUTE16,
			C1.ATTRIBUTE17,
			C1.ATTRIBUTE18,
			C1.ATTRIBUTE19,
			C1.ATTRIBUTE20,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),		--LAST_UPDATED_BY,
			C1.LAST_UPDATE_LOGIN,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),			--CREATED_BY,
			C1.CREATION_DATE,
			C1.OBJECT_VERSION_NUMBER,
			C1.PARTY_ID
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	--COMMIT;
END;
/

--ALTER TRIGGER HR_ALL_ORGANIZATION_UNITS_OVN ENABLE;
--ALTER TRIGGER HR_ALL_ORGANIZATION_UNITS_WHO ENABLE;
